#include <iostream>
using namespace std;

int N, Q, l, r;

void proveraNiza(int l, int r, int *A, int br) {
    int niz[br];
    for(int i=l-1; i<=r-1; i++) {
        int j = 0;
        niz[j] = A[i];
        j++;
    }
    if(br == 1) {
        cout << "NE" << "\n";
        return;
    }
    if(niz[0] == 1) {
        for(int i=0; i<br; i++){
            if (niz[i]==2) {
                int temp = i+1;
                for(int j=temp; j<br; j++){
                    if (niz[j]==2) cout << "NE" << "\n";
                    return;
            	}
        	}
    	}
	}
	else if(niz[0] == 2) {
        for(int i=0; i<br; i++){
            if (niz[i]==1) {
                int temp = i+1;
                for(int j=temp; j<br; j++){
                    if (niz[j]==1) cout << "NE" << "\n";
                    return;
            	}
        	}
    	}
	}
	else {
        cout << "DA" << "\n";
        return;
	}
	cout << "DA" << "\n";
}

int main()
{
    cin>>N;
    int A[N];
    for(int i = 0; i<N; i++) {
        cin >> A[i];
    }
    cin>>Q;
    for(int i = 0; i<Q; i++) {
        cin >> l >> r;
        int br = r-l+1;
        proveraNiza(l, r, A, br);
    }
    return 0;
}